#include "definition.h"

risc::Definition::Definition(SgNode *ast_node, Type type):
  ast_node_(ast_node),
  type_(type)
{ }

std::string
risc::Definition::get_name()
{
  return "IMPLEMENT ME get_name";
}

std::string
risc::Definition::get_ast_type_name()
{
  return "IMPLEMENT ME get_ast_type_name";
}

SgNode*
risc::Definition::get_ast_node()
{
  return ast_node_;
}

SgType*
risc::Definition::get_ast_type()
{
  return ast_type_pointer_;
}


bool
risc::Definition::has_source_location()
{
  if(isSgLocatedNode(ast_node_)) {
    return !(isSgLocatedNode(
                 ast_node_)->get_file_info()->isCompilerGenerated());
  } else {
    return false;
  }
}

std::string
risc::Definition::get_file_name()
{
  SgLocatedNode* located_node = isSgLocatedNode(ast_node_);
  Sg_File_Info *file = located_node->get_file_info();
  return file->get_filenameString();
}

int
risc::Definition::get_line_number()
{
  SgLocatedNode* located_node = isSgLocatedNode(ast_node_);
  Sg_File_Info *file = located_node->get_file_info();
  return file->get_line();
}

int
risc::Definition::get_position_in_line()
{
  SgLocatedNode* located_node = isSgLocatedNode(ast_node_);
  Sg_File_Info *file = located_node->get_file_info();
  return file->get_col();
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
