#ifndef PRIMITIVE_CHANNEL_INSTANCE_H_INCLUDED_
#define PRIMITIVE_CHANNEL_INSTANCE_H_INCLUDED_

#include <vector>

#include "channel_instance.h"
#include "rose.h"

namespace risc {

class PrimitiveChannel;

class PrimitiveChannelInstance: public ChannelInstance {

public:

  /**
   * \brief Default constructor
   */
  explicit PrimitiveChannelInstance(SgVariableDefinition *ast_node,
      PrimitiveChannel *definition);


  /**
   * \brief Get function for the name of the ast type of the channel instance
   * \return Name as std::string
   */
  virtual std::string get_ast_type_name();

  PrimitiveChannel *definition_;

private:
  /**
   * \brief Disabled copy constructor
   */
  PrimitiveChannelInstance(const PrimitiveChannelInstance &pci);
};

typedef std::vector<PrimitiveChannelInstance*>
            PrimitiveChannelInstanceVector;
typedef std::vector<PrimitiveChannelInstance*>::iterator
            PrimitiveChannelInstanceVectorIter;
typedef std::vector<PrimitiveChannelInstance*>::const_iterator
            PrimitiveChannelInstanceVectorConstIter;
typedef std::vector<PrimitiveChannelInstance*>::iterator
            PrimitiveChannelInstanceVectorIter;

} // end namespace risc

#endif /* PRIMITIVE_CHANNEL_INSTANCE_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
