#ifndef GRAPH_ALGORITHMS_H_INCLUDED_
#define GRAPH_ALGORITHMS_H_INCLUDED_

#include "rose.h"

namespace risc
{

// sa = static analysis
namespace sa
{

// ga = graph analysis
namespace ga
{

enum Color {White, Gray, Black};

typedef std::pair<SgGraphNode*, Color> ColoredGraphNode;
typedef std::vector<ColoredGraphNode> ColoredNodeVector;


std::set<SgFunctionSymbol*> dfs(SgFunctionSymbol *root_func_symbol,
    SgIncidenceDirectedGraph &graph);

void dfs_visit(ColoredGraphNode& root, ColoredNodeVector &nodes,
    SgIncidenceDirectedGraph &graph);


} // end namesapce dfs

} // end namesapce sa

} // end namespace risc

#endif /* GRAPH_ALGORITHMS_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
