#include "file_classifier.h"


StringUtility::FileNameLibrary
risc::tools::get_library(int file_id)
{
  std::string sourceDirectory = ROSE::getWorkingDirectory();
  std::string filename(Sg_File_Info::getFilenameFromID(file_id).c_str());

  StringUtility::FileNameClassification classification =
    StringUtility::classifyFileName(filename,sourceDirectory,
                       StringUtility::getOSType());

  return classification.getLibrary();
}

StringUtility::FileNameLibrary
risc::tools::get_library(Sg_File_Info* X)
{
  SgFile* file = TransformationSupport::getFile(X->get_parent());
  ROSE_ASSERT(file != NULL);
  std::string sourceFilename = file->getFileName();
  std::string sourceDirectory =
    StringUtility::getPathFromFileName(sourceFilename);

  StringUtility::FileNameClassification classification =
  StringUtility::classifyFileName(X->get_filenameString(), sourceDirectory,
                     StringUtility::getOSType());


  //std::cout << "library: " << classification.getLibrary() << std::endl;

  return classification.getLibrary();
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
