#include "search_for_typedef_declaration.h"

SgTypedefDeclaration*
risc::tools::find_typedef_declaration
(std::string class_name, std::string qualified_namespace, SgNode* root_node)
{
  std::string class_with_qualifier = qualified_namespace + class_name;
  Rose_STL_Container<SgNode*> type_definitions =
    NodeQuery::querySubTree(root_node, V_SgTypedefDeclaration);

  for(Rose_STL_Container<SgNode*>::iterator
      iter = type_definitions.begin();
      iter != type_definitions.end(); iter++) {

    SgTypedefDeclaration *type_decl = isSgTypedefDeclaration(*iter);

    std::string complete_class_namespace = type_decl->get_qualified_name();

    if(!complete_class_namespace.compare(class_with_qualifier)) {

      return type_decl;
    }
  }

  return NULL;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
